/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.stimmeingabe.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiKonfiguration;
import de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiKonfigurationUK;

public abstract class AbstractStimmeingabePlausiKonfigurationDAO extends de.ivu.elect.jee.entity.AbstractDAO<StimmeingabePlausiKonfiguration,
        de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiKonfigurationPK
    , StimmeingabePlausiKonfigurationUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractStimmeingabePlausiKonfigurationDAO.class);

  public AbstractStimmeingabePlausiKonfigurationDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiKonfigurationPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public StimmeingabePlausiKonfiguration findByPrimaryKey(
        de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiKonfigurationPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected StimmeingabePlausiKonfiguration findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(StimmeingabePlausiKonfiguration.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: WahlAndErgebniseingangsartAndGebietsartAndTypNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT obj FROM StimmeingabePlausiKonfiguration obj WHERE obj.wahl = ?1 AND obj.ergebniseingangsart = ?2 AND obj.gebietsart = ?3 AND obj.typ = ?4<br>
      * SQL: <br>
      */
     public java.util.List<StimmeingabePlausiKonfiguration> findByWahlAndErgebniseingangsartAndGebietsartAndTyp( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiErgebniseingangsart ergebniseingangsart,  @javax.annotation.Nonnull de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiGebietsart gebietsart,  @javax.annotation.Nonnull de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiTyp typ) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiErgebniseingangsart ergebniseingangsartCheckedAndAttached =  checkAndAttach(ergebniseingangsart, de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiErgebniseingangsart.class, "ergebniseingangsart"); ;
		  			  de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiGebietsart gebietsartCheckedAndAttached =  checkAndAttach(gebietsart, de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiGebietsart.class, "gebietsart"); ;
		  			  de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiTyp typCheckedAndAttached =  checkAndAttach(typ, de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiTyp.class, "typ"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEINGABE_PLAUSI.WahlAndErgebniseingangsartAndGebietsartAndTyp")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, ergebniseingangsartCheckedAndAttached)
                                        .setParameter(3, gebietsartCheckedAndAttached)
                                        .setParameter(4, typCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndErgebniseingangsartAndGebietsartAndTyp - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("StimmeingabePlausiKonfiguration, findByWahlAndErgebniseingangsartAndGebietsartAndTyp - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", ergebniseingangsart:'"+ergebniseingangsart+"'"
           + ", gebietsart:'"+gebietsart+"'"
           + ", typ:'"+typ+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndErgebniseingangsartAndGebietsartAndTyp(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndErgebniseingangsartAndGebietsartNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT obj FROM StimmeingabePlausiKonfiguration obj WHERE obj.wahl = ?1 AND obj.ergebniseingangsart = ?2 AND obj.gebietsart = ?3<br>
      * SQL: <br>
      */
     public java.util.List<StimmeingabePlausiKonfiguration> findByWahlAndErgebniseingangsartAndGebietsart( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiErgebniseingangsart ergebniseingangsart,  @javax.annotation.Nonnull de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiGebietsart gebietsart) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiErgebniseingangsart ergebniseingangsartCheckedAndAttached =  checkAndAttach(ergebniseingangsart, de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiErgebniseingangsart.class, "ergebniseingangsart"); ;
		  			  de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiGebietsart gebietsartCheckedAndAttached =  checkAndAttach(gebietsart, de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiGebietsart.class, "gebietsart"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEINGABE_PLAUSI.WahlAndErgebniseingangsartAndGebietsart")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, ergebniseingangsartCheckedAndAttached)
                                        .setParameter(3, gebietsartCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndErgebniseingangsartAndGebietsart - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("StimmeingabePlausiKonfiguration, findByWahlAndErgebniseingangsartAndGebietsart - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", ergebniseingangsart:'"+ergebniseingangsart+"'"
           + ", gebietsart:'"+gebietsart+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndErgebniseingangsartAndGebietsart(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndErgebniseingangsartAndTypNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT obj FROM StimmeingabePlausiKonfiguration obj WHERE obj.wahl = ?1 AND obj.ergebniseingangsart = ?2 AND obj.typ = ?3<br>
      * SQL: <br>
      */
     public java.util.List<StimmeingabePlausiKonfiguration> findByWahlAndErgebniseingangsartAndTyp( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiErgebniseingangsart ergebniseingangsart,  @javax.annotation.Nonnull de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiTyp typ) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiErgebniseingangsart ergebniseingangsartCheckedAndAttached =  checkAndAttach(ergebniseingangsart, de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiErgebniseingangsart.class, "ergebniseingangsart"); ;
		  			  de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiTyp typCheckedAndAttached =  checkAndAttach(typ, de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiTyp.class, "typ"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEINGABE_PLAUSI.WahlAndErgebniseingangsartAndTyp")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, ergebniseingangsartCheckedAndAttached)
                                        .setParameter(3, typCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndErgebniseingangsartAndTyp - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("StimmeingabePlausiKonfiguration, findByWahlAndErgebniseingangsartAndTyp - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", ergebniseingangsart:'"+ergebniseingangsart+"'"
           + ", typ:'"+typ+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndErgebniseingangsartAndTyp(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT obj FROM StimmeingabePlausiKonfiguration obj WHERE obj.wahl = ?1<br>
      * SQL: <br>
      */
     public java.util.List<StimmeingabePlausiKonfiguration> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEINGABE_PLAUSI.Wahl")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahl - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("StimmeingabePlausiKonfiguration, findByWahl - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahl(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiKonfigurationUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiKonfigurationUK uk,
        de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiKonfigurationPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

    public de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiKonfiguration findByUK(de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiKonfigurationUK uk){
        throw new UnsupportedOperationException("Kein UK definiert");
    }


}